mbox-0.3.4: Read and write standard mailbox files.

Copyright | (c) Gershom Bazerman 2009
License | BSD 3 Clause
Maintainer | gershomb@gmail.com
Stability | experimental
Safe Haskell | Safe
Language | Haskell98

Data.MBox.String

Description

Reads and writes mboxrd files as per http://www.qmail.org/man/man5/mbox.html.

This parser is written to be a streaming parser. Given a lazy source of data and a streaming consumer, you should be able to analyze arbitrary mbox files in constant space.

Synopsis

- type MBox = [Message]
- data Message = Message {
  - fromLine :: String
  - headers :: [Header]
  - body :: String
  }
- type Header = (String, String)
- parseMBox :: String -> MBox
- parseForward :: Message -> Message
- parseDateHeader :: String -> Maybe UTCTime
- showMessage :: Message -> String
- showMBox :: MBox -> String
- getHeader :: (Header -> Bool) -> Message -> [String]
- isID :: Header -> Bool
- isDate :: Header -> Bool

# Documentation

type MBox = [Message] Source #

data Message Source #

Constructors

Message |

Fields

- fromLine :: String
- headers :: [Header]
- body :: String

Instances

Read Message Source # |
Methods readsPrec :: Int -> ReadS Message # readList :: ReadS [Message] # readPrec :: ReadPrec Message # readListPrec :: ReadPrec [Message] #
Show Message Source # |
Methods showsPrec :: Int -> Message -> ShowS # show :: Message -> String # showList :: [Message] -> ShowS #

type Header = (String, String) Source #

parseMBox :: String -> MBox Source #

Reads a string as an mbox file.

parseForward :: Message -> Message Source #

Attempts to retrieve the contents of a forwarded message from an enclosing message.

parseDateHeader :: String -> Maybe UTCTime Source #

Reads a date header as a UTCTime

showMessage :: Message -> String Source #

Renders an individual message into a String.

showMBox :: MBox -> String Source #

Renders an MBox into a String

getHeader :: (Header -> Bool) -> Message -> [String] Source #

isID :: Header -> Bool Source #

Header accessors

isDate :: Header -> Bool Source #